package net.kldp.zeta.uploader;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.swing.JApplet;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.TransferHandler;


public class MoniUploader extends JApplet {
	private static final long serialVersionUID = 1L;

	private String pageUrl; // ex) http://wiki.kldp.org/wiki.php/MozillaFirefox
	private String page; // ex) /wiki.php/MozillaFirefox

	public void init(){
		pageUrl = getParameter("pageUrl");
		if(pageUrl == null) pageUrl = getDocumentBase().toString();
		page = getParameter("page");
		if(page == null){
			page = getDocumentBase().getFile().toString();
			if(page.indexOf('/') != -1){
				String[] strs = page.split("/");
				page = strs[strs.length - 1];
			}
		}
		//FIXME for test
		pageUrl = "http://localhost/moniwiki/wiki.php/FrontPage";
		page = "FrontPage";
	}
	
	JLabel status;
	public MoniUploader(){
		JPanel pane = new JPanel();
		add(pane, "Center");
		pane.setTransferHandler(new FileTransferHandler());
		status = new JLabel("غ");
		add(status, "South");
	}
	
	class FileTransferHandler extends TransferHandler{
		private static final long serialVersionUID = 1L;
		
		@Override
		public boolean canImport(JComponent dest, DataFlavor[] flavors) {
			//TODO   
			for(DataFlavor flavor : flavors){
				if(flavor.isFlavorJavaFileListType()){
					return true;
				}
			}
			return false;
		}
		
		@Override
		public boolean importData(JComponent src, Transferable transferable) {
			DataFlavor[] flavors = transferable.getTransferDataFlavors();
			DataFlavor fileFlavors = null;
			for(DataFlavor flavor : flavors){
				if(flavor.isFlavorJavaFileListType()){
					fileFlavors = flavor;
				}
			}
			if(fileFlavors != null){
				try{
					List<File> files = (List<File>) transferable.getTransferData(fileFlavors);
					for(File file : files){
						processFile(file);
					}
				}catch(Exception e){
					e.printStackTrace();
				}
			}
			return true;
		}
		
		public void processFile(File file){
			try {
				MoniConnector.getConnection(pageUrl).upload(file);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
