package net.kldp.zeta.uploader;

import java.io.File;
import java.io.IOException;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.multipart.FilePart;
import org.apache.commons.httpclient.methods.multipart.MultipartRequestEntity;
import org.apache.commons.httpclient.methods.multipart.Part;
import org.apache.commons.httpclient.methods.multipart.StringPart;

public class PageConnection {
	private PostMethod method;
	
	public PageConnection(String url){
		method = new PostMethod(url);
	}
	
	public int upload(String filePath) throws IOException{
		return upload(new File(filePath));
	}
	
	public int upload(File file) throws IOException{
		Part[] parts = {
				new StringPart("action", "UploadFile"),
				new StringPart("replace", "0"),  //0:rename 1:replace if it already exist
				new FilePart("upfile", file)
				};
		method.setRequestEntity(
				new MultipartRequestEntity(parts, method.getParams())
				);
		HttpClient client = new HttpClient();
		int status = client.executeMethod(method);
		return status;
	}
}
