package org.kldp.zeta.interpret4j;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;
import org.apache.commons.cli.PosixParser;
import org.kldp.zeta.interpret4j.Interpreter.Type;

/**
 * @author ni2
 * @version 0.1, 11/06/06
 * This code licensed under the terms of the LGPL.  See doc/LICENSE.
 */
public class Main {

	public static void main(String[] args) throws Exception {
		Interpreter i = Interpreter.instance();
		
		Option option;
		Options options = new Options();
		
		options.addOption("h", "help", false, "print this message");
		options.addOption(option = new Option("e", "eval", true, "eval"));
		option.setArgName("statement");
		options.addOption(option = new Option("l", "language", true, "language"));
		option.setArgName("language");
		
		CommandLineParser parser = new PosixParser();
		CommandLine cmd = parser.parse(options, args);
		
		Object result = null;
		if(cmd.hasOption("h")){
			new HelpFormatter().printHelp("i", options, true);
			return;
		}else if(cmd.hasOption("e")){
			if(cmd.hasOption("l")){
				result = i.eval(cmd.getOptionValue("e"),
						Type.valueOf(cmd.getOptionValue("l").toUpperCase()));
			}else{
				throw new ParseException("Unexpected exception: The -l option must be given.");
			}
		}else{
			for(String s : cmd.getArgs()){
				try{
					result = i.interpretFromFile(s);
				}catch(NullPointerException e){
					System.out.println(s + " : UNSUPPORTED FILE TYPE.");
				}
			}
		}
		if(result != null)
			System.out.println(result);
	}

}
