package org.kldp.zeta.interpret4j.language;

import org.kldp.zeta.interpret4j.Interpreter;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;

/**
 * @author ni2
 * @version 0.1, 10/04/06
 * This code licensed under the terms of the LGPL.  See doc/LICENSE.
 */
public class JavascriptSupport implements ILanguageSupport{
	private static JavascriptSupport instance;
	private Context javascript;
	private Scriptable scope;
	
	public JavascriptSupport(){
		javascript = Context.enter();
		scope = javascript.initStandardObjects();
	}
	
	public static JavascriptSupport instance(){
		if(instance == null)
			instance = new JavascriptSupport();
		return instance;
	}

	//http://www.mozilla.org/rhino/tutorial.html#RunScript
	public Object eval(String source) throws Exception {
		return javascript.evaluateString(scope, source, "<cmd>", 1, null);
	}

	//FIXME
	public Object interpretFromFile(String fileName) throws Exception {
		return eval(Interpreter.loadSource(fileName));
	}

}
