package org.kldp.zeta.interpret4j.language;

import org.jruby.IRuby;
import org.jruby.Ruby;
import org.kldp.zeta.interpret4j.Interpreter;

/**
 * @author ni2
 * @version 0.1, 10/04/06
 * This code licensed under the terms of the LGPL.  See doc/LICENSE.
 */
public class RubySupport implements ILanguageSupport{
	private static RubySupport instance;
	private IRuby ruby;
	
	public RubySupport(){
		ruby = Ruby.getDefaultInstance();
	}
	
	public static RubySupport instance(){
		if(instance == null)
			instance = new RubySupport();
		return instance;
	}

	public Object eval(String source) throws Exception {
		return ruby.evalScript(source);
	}

	public Object interpretFromFile(String fileName) throws Exception {
		return eval(Interpreter.loadSource(fileName));
	}

}