package ni2.likewind.image;

import net.sourceforge.jiu.codecs.CodecMode;
import net.sourceforge.jiu.codecs.ImageCodec;
import net.sourceforge.jiu.codecs.jpeg.JPEGCodec;
import net.sourceforge.jiu.data.PixelImage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;

public class ImageWriter {
	private org.eclipse.swt.graphics.ImageLoader loader;
	private String fileName;
	private ImageType targetType;

	private enum ImageType{
		BMP(SWT.IMAGE_BMP),
		GIF(SWT.IMAGE_GIF),
		ICO(SWT.IMAGE_ICO),
		JPEG(SWT.IMAGE_JPEG),
		PNG(SWT.IMAGE_PNG),
		RLE(SWT.IMAGE_BMP_RLE);
		
		int SWT_TYPE;
		ImageType(int SWT_TYPE){
			this.SWT_TYPE = SWT_TYPE;
		}
		
		static ImageType typeOf(String lowerFileName){
			if(lowerFileName.endsWith("bmp")) return BMP;
			if(lowerFileName.endsWith("gif")) return GIF; //FIXME 16/32bit -> 256 색상 지원
			if(lowerFileName.endsWith("ico")) return ICO;
			if(lowerFileName.endsWith("jpeg")) return JPEG;
			if(lowerFileName.endsWith("jpg")) return JPEG;
			//"Unsupported or unrecognized format". 현재 버전의 SWT에서 지원되지 않음
			//if(lowerFileName.endsWith("png")) return PNG;
			if(lowerFileName.endsWith("rle")) return RLE;
			return null;
		}
	}
	
	/*
	 * 확장명으로부터 이미지 타입을 자동 감지한다.
	 */
	public ImageWriter(String fileName, Image source){
		this(fileName, ImageType.typeOf(fileName.toLowerCase()), source);
	}
	
	/*
	 * SWT.IMAGE_JPEG 등의 TYPE을 받는다.
	 */
	public ImageWriter(String fileName, ImageType targetType, Image source){
		loader = new org.eclipse.swt.graphics.ImageLoader();
		loader.data = new ImageData[]{source.getImageData()};
		this.fileName = fileName;
		this.targetType = targetType;
	}
	
	public boolean write(){
		boolean result = false;
		try{
			loader.save(fileName, targetType.SWT_TYPE);
			result = true;
		}catch(SWTException e){
			//TODO ignore
		}catch(NullPointerException e){
			//TODO ignore
		}
		return result;
	}
	
	//FIXME ImageWriter 클래스 리팩터
	public boolean writeUsingJIU(String fileName){
		boolean result = false;
		try {
			PixelImage pi = net.sourceforge.jiu.codecs.ImageLoader.load(fileName);
			if(pi != null){
				ImageCodec codec = new JPEGCodec();
				codec.setFile(fileName, CodecMode.SAVE);
				codec.process();
				result = true;
			}
		} catch (Exception e){
			e.printStackTrace();
		}
		return result;
	}
}
