package ni2.likewind.io;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.net.URI;

import org.apache.batik.transcoder.TranscoderException;
import org.apache.batik.transcoder.TranscoderInput;
import org.apache.batik.transcoder.TranscoderOutput;
import org.eclipse.gmf.runtime.draw2d.ui.render.awt.internal.svg.SWTImageTranscoder;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Image;

public class SVGImageLoader {
	
	public Image load(Device device, String fileName){
		URI file = new File(fileName).toURI();
		Image image = null;
		
		//new Graphics2DToGraphicsAdaptor();
		//SVGImage svg;
		SWTImageTranscoder transcoder = new SWTImageTranscoder();
		try {
			ByteArrayOutputStream output = new ByteArrayOutputStream();
			transcoder.transcode(
					new TranscoderInput(file.toString()),
					new TranscoderOutput(output));
			/*
			 * 현재는 아무런 이유 없이 다음 예외가 일어난다. 
			 
				java.lang.UnsupportedOperationException
				at org.eclipse.gmf.runtime.draw2d.ui.render.awt.internal.graphics.Graphics2DToGraphicsAdaptor.configureComposite(Graphics2DToGraphicsAdaptor.java:248)
				at org.eclipse.gmf.runtime.draw2d.ui.render.awt.internal.graphics.Graphics2DToGraphicsAdaptor.configureGraphics(Graphics2DToGraphicsAdaptor.java:115)
				...
				
			 * 해당 코드를 보면

				private boolean configureComposite(Composite c) {
					if (c instanceof AlphaComposite) {
						AlphaComposite ac = (AlphaComposite)c;
						
						// swt graphics doesn't support blitting onto transparency mask explicitly.
						if (ac.getAlpha() != 1.0)
							throw new UnsupportedOperationException();
						
						swtGC.setAlpha(Math.round(ac.getAlpha() * 255));
						if (ac.getRule() == AlphaComposite.SRC_OVER)
							return true;
					} 
			
					return false;
				}
				
			 * 적절한 해결책을 찾고 있음.
			 */
			output.flush();
			output.close();
			
			byte[] imgData = output.toByteArray();
			image = new Image(device, new ByteArrayInputStream(imgData));
		} catch (TranscoderException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return image;
	}
}
