package ni2.likewind.io;

import java.io.File;
import java.io.IOException;

import ni2.likewind.image.ImageLoader;

import org.apache.commons.vfs.FileObject;
import org.apache.commons.vfs.FileSystemException;
import org.apache.commons.vfs.FileSystemManager;
import org.apache.commons.vfs.VFS;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Image;

public class VFSImageLoader {
	
	public Image loadFromArchive(Device device, String fileName, String ext){
		try {
			File file = new File(fileName);
			fileName = file.getCanonicalPath();
		} catch (IOException e) {
			e.printStackTrace();
		}
		Image image = null;
		try {
			FileSystemManager fsManager = VFS.getManager();
			//uri ex) zip:/C:/lib/aJarFile.zip
			String uri = ext + ":/" + fileName;
			FileObject archive = fsManager.resolveFile(uri);
			FileObject[] children = archive.getChildren();
			for(FileObject o : children){
				//FIXME 다중 파일 구현
				if(ImageLoader.canLoadFromSWT(o.getName().getBaseName())){
					image = new Image(device, o.getContent().getInputStream());
					break;
				}
			}
			
		} catch (FileSystemException e) {
			e.printStackTrace();
		}
		return image;
	}
}
