package ni2.likewind.ui;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;

/**
 * @author ni2 (netisinfinite@gmail.com)
 * @version 0.1 11/13/06
 * This code licensed under the terms of the GPL.  See doc/LICENSE.
 */
public class ImageCanvasData {
	public double magnification = 1;
	public Image image;
	/*
	 * swt.graphics.Image의 소스를 보면 알겠지만, getSize()와 getImageData()의 차이는 크다.
	 * Image 객체와 별개의 완전히 새로운 ImageData를 만들고 채우는 과정에서 속도와 자원 소모가 심하다.
	 * (테스트 결과로는 2M~8M 정도?)
	 */
	//private static ImageData imageData;
	public int imageWidth, imageHeight, imageWidthMag, imageHeightMag;
	//public int viewportX, viewportY;
	//public int canvasWidth, canvasHeight;
	
	public void setImage(Image image){
		this.image = image;
		setImageSize(image.getBounds());
		//imageData = image.getImageData();
	}
	
	public void setImageSize(Rectangle size){
		imageWidth = size.width;
		imageHeight = size.height;
		updateMagnification();
	}
	
	private void updateMagnification(){
		imageWidthMag = (int)(imageWidth * magnification);
		imageHeightMag = (int)(imageHeight * magnification);
	}
	
	public void setMagnification(double mag){
		magnification = mag;
		updateMagnification();
		
	}
	
	public void reset(){
		magnification = 1;
	}
	
	public void clear(){
		if(image != null){
			image.dispose();
			image = null;
		}
		reset();
	}
	
	public boolean zoomIn(){
		if (image != null){
			setMagnification(magnification * 2);
			return true;
		}
		return false;
	}
	
	public boolean zoomOut(){
		if (image != null){
			setMagnification(magnification * 0.5);
			return true;
		}
		return false;
	}
}
