package net.kldp.zeta.monimoni.action;

import net.kldp.zeta.monimoni.data.Wiki;
import net.kldp.zeta.monimoni.data.WikiPage;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Tree;

/**
 * 
 * 생성시에 주어진 Tree에서 Wiki 혹은 그 하위 WikiPage가 선택되었을 때 활성화되는 Action 클래스이다. 
 * @author Ni2
 *
 */
public abstract class AbstractWikiAction extends Action {
	protected Wiki selectedWiki;
	private boolean selectWiki;
	private boolean selectWikipage;
	
	/**
	 * 
	 * @param tree
	 * @param wikiPage WikiPage가 선택되었을 때에도 활성화 할 것인지의 여부
	 */
	public AbstractWikiAction(Tree tree, boolean wiki, boolean wikiPage){
		this.selectWiki = wiki;
		this.selectWikipage = wikiPage;
		tree.addSelectionListener(new SelectionListener(){
			public void widgetDefaultSelected(SelectionEvent e) {}

			public void widgetSelected(SelectionEvent e) {
				Object data = e.item.getData();
				if(data instanceof Wiki){
					selectedWiki = (Wiki) data;
					if(selectWiki) setEnabled(true);
				}else if(data instanceof WikiPage){
					selectedWiki = ((WikiPage) data).getParent();
					if(selectWikipage) setEnabled(true);
				}
			}
		});
		setEnabled(false);
	}
}
