package net.kldp.zeta.monimoni.action;

import net.kldp.zeta.commons.resource.Messages;
import net.kldp.zeta.monimoni.data.Wiki;
import net.kldp.zeta.monimoni.manager.WikiManager;
import net.kldp.zeta.monimoni.ui.dialog.AddWikiDialog;

import org.apache.commons.httpclient.URIException;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;

public class AddWikiAction extends Action{
	public AddWikiAction(){
		setText(Messages.get("AddWikiText"));
		setToolTipText(Messages.get("AddWikiToolTipText"));
	}
	
	@Override
	public void run(){
		AddWikiDialog dlg = new AddWikiDialog(
				Display.getCurrent().getActiveShell());
		if (dlg.open() == Window.OK) {
			try {
				Wiki w = new Wiki(
						dlg.getURI(),
						dlg.getCharset(),
						dlg.getType());
				WikiManager.instance().add(w);
			} catch (URIException e) {
				ErrorDialog.openError(
						Display.getCurrent().getActiveShell(),
						Messages.get("Error"),
						Messages.get("IllegalWikiUriError"), null, 0);
				e.printStackTrace();
			}
	    }
	}
}
