package net.kldp.zeta.monimoni.action;

import java.util.List;

import net.kldp.zeta.commons.resource.Messages;
import net.kldp.zeta.monimoni.data.WikiPage;
import net.kldp.zeta.monimoni.manager.WikiManager;
import net.kldp.zeta.monimoni.ui.ClientWindow;
import net.kldp.zeta.monimoni.ui.tab.PageTabItem;

import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

public class CloseWikiPageAction extends AbstractWikiAction {
	private ClientWindow window;
	private Tree tree;
	
	public CloseWikiPageAction(Tree tree, ClientWindow window){
		super(tree, false, true);
		this.window = window;
		this.tree = tree;
		setText(Messages.get("RemoveWikiPageText"));
		setToolTipText(Messages.get("RemoveWikiPageToolTipText"));
	}
	
	@Override
	public void run(){
		WikiManager manager = WikiManager.instance();
		for(TreeItem item : tree.getSelection()){
			WikiPage wikiPage = (WikiPage) item.getData();
			List<PageTabItem> tabItems = window.getPageFolder().getItems();
			for(PageTabItem tabItem : tabItems){
				if(tabItem.getWikiPage() == wikiPage){
					tabItem.dispose();
					tabItems.remove(tabItem);
					break;
				}
			} 
			manager.remove(wikiPage);
		}
	}
}
