package net.kldp.zeta.monimoni.action;

import net.kldp.zeta.commons.resource.Messages;
import net.kldp.zeta.monimoni.data.WikiPage;
import net.kldp.zeta.monimoni.manager.WikiManager;
import net.kldp.zeta.monimoni.ui.ClientWindow;

import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Tree;

public class OpenWikiPageAction extends AbstractWikiAction{
	private ClientWindow window;
	
	public OpenWikiPageAction(Tree tree, ClientWindow window){
		super(tree, true, true);
		this.window = window;
		setText(Messages.get("OpenWikiPageText"));
		setToolTipText(Messages.get("OpenWikiPageToolTipText"));
	}
	
	@Override
	public void run(){
		InputDialog dlg = new InputDialog(
				Display.getCurrent().getActiveShell(),
				Messages.get("OpenWikiPageText"),
				Messages.get("OpenWikiPageDialogText"), null, null);
		if (dlg.open() == Window.OK) {
			//FIXME 404 File Not Found 에러 처리
			WikiManager manager = WikiManager.instance();
			WikiPage page = new WikiPage(selectedWiki, dlg.getValue());
			manager.add(page);
			window.getPageFolder().openPage(page);
	    }
	}
}
