package net.kldp.zeta.monimoni.ui.dialog;

import net.kldp.zeta.commons.resource.Messages;
import net.kldp.zeta.monimoni.data.Wiki.Type;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class AddWikiDialog extends AbstractDialog {
	private static final String DEFAULT_CHARSET = "euc-kr";
	
	private String charset;
	private String uri;
	private Type type;
	
	public AddWikiDialog(Shell parentShell) {
		super(parentShell, Messages.get("AddWikiDialogText"));
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
        if (buttonId == IDialogConstants.OK_ID) {
        	charset = txtCharset.getText();
        	type = Type.byName(cmbType.getItem(cmbType.getSelectionIndex()));
        	uri = txtUri.getText();
        }
        super.buttonPressed(buttonId);
    }
	
	private Combo cmbType;
	private Text txtCharset;
	private Text txtUri;
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite composite = (Composite) super.createDialogArea(parent);
		
		new Label(composite, SWT.NONE).setText(Messages.get("WikiType"));
	    cmbType = new Combo(composite, SWT.DROP_DOWN | SWT.READ_ONLY);
	    for(Type t : Type.values()){
	    	cmbType.add(t.getName());
	    }
	    cmbType.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
	    cmbType.select(0);
		new Label(composite, SWT.NONE).setText(Messages.get("WikiCharset"));
		txtCharset = new Text(composite, SWT.BORDER);
		txtCharset.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		txtCharset.setText(DEFAULT_CHARSET);
	    new Label(composite, SWT.NONE).setText(Messages.get("WikiUrl"));
	    txtUri = new Text(composite, SWT.BORDER);
	    txtUri.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
	    
		return composite;
	}

	public String getCharset() {
		return charset;
	}

	public Type getType() {
		return type;
	}

	public String getURI() {
		return uri;
	}
}
