package net.kldp.zeta.monimoni.ui.dialog;

import net.kldp.zeta.commons.resource.Messages;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class LoginDialog extends AbstractDialog {
	private String id;
	private String password;
	
	public LoginDialog(Shell parentShell) {
		super(parentShell, Messages.get("LoginWikiDialogText"));
	}
	
	@Override
	protected void buttonPressed(int buttonId) {
        if (buttonId == IDialogConstants.OK_ID) {
        	id = txtId.getText();
        	password = txtPassword.getText();
        }
        super.buttonPressed(buttonId);
    }
	
	private Text txtId;
	private Text txtPassword;
	
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite composite = (Composite) super.createDialogArea(parent);
		
		new Label(composite, SWT.NONE).setText(Messages.get("WikiId"));
		txtId = new Text(composite, SWT.BORDER);
		txtId.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		txtId.setTextLimit(20);
	    new Label(composite, SWT.NONE).setText(Messages.get("WikiPassword"));
	    txtPassword = new Text(composite, SWT.BORDER);
	    txtPassword.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
	    txtPassword.setEchoChar('*');
	    txtPassword.setTextLimit(15); //FIXME 위키의 Type에 의존하도록 변경
	    
		return composite;
	}
	
	public String getId() {
		return id;
	}
	public String getPassword() {
		return password;
	}
}
