package net.kldp.zeta.monimoni.ui.tab;

import java.util.ArrayList;
import java.util.List;

import net.kldp.zeta.monimoni.Client;
import net.kldp.zeta.monimoni.data.WikiPage;
import net.kldp.zeta.monimoni.data.Wiki.Type;
import net.sf.colorer.ParserFactory;
import net.sf.colorer.swt.ColorManager;
import net.sf.colorer.swt.TextColorer;

import org.eclipse.jface.text.source.SourceViewer;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.widgets.Composite;

public class PageTabFolder {
	private CTabFolder folder;
	private List<PageTabItem> items = new ArrayList<PageTabItem>();
	
	public PageTabFolder(Composite parent, int style){
		folder = new CTabFolder(parent, style);
	}
	
	public CTabFolder getTabFolderWidget(){
		return folder;
	}
	
	public List<PageTabItem> getItems(){
		return items;
	}
	
	public void openPage(WikiPage page){
		//TODO client pool 만들것
		Client client = page.getParent().getClient();
		
		PageTabItem pageTab = new PageTabItem(page, this);
		items.add(pageTab);
		
		configViewer(pageTab.getEditor());
		pageTab.getDocument().set(client.getRaw(page.getName()));
		this.getTabFolderWidget().setSelection(pageTab.getTabItem());
	}
	
	private static final String COLORER_CATALOG_PATH = "colorer/catalog.xml";
	public void configViewer(SourceViewer viewer){
		final ParserFactory pf = new ParserFactory(COLORER_CATALOG_PATH);
		final TextColorer textColorer = new TextColorer(pf, new ColorManager());
		textColorer.attach(viewer.getTextWidget());
		//TODO 위키 타입에 따라 변형되도록
		textColorer.chooseFileType(Type.MONIWIKI.getExtension());
		textColorer.setCross(true, true);
		textColorer.setRegionMapper("default", true);
	}
}
