package net.kldp.zeta.monimoni.ui.tree;

import net.kldp.zeta.monimoni.data.Wiki;
import net.kldp.zeta.monimoni.data.WikiPage;
import net.kldp.zeta.monimoni.event.ChangeEvent;
import net.kldp.zeta.monimoni.event.ChangeListener;
import net.kldp.zeta.monimoni.manager.WikiManager;

import org.eclipse.jface.action.MenuManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

public class WikiTree implements ChangeListener{
	private final Tree tree;
	
	public WikiTree(Composite parent, int style){
		tree = new Tree(parent, style);
	}
	
	public void setPopupMenu(MenuManager manager){
		final Menu menu = manager.createContextMenu(tree);
		Listener listener = new Listener() {
			public void handleEvent(Event event) {
				switch(event.type){
				case SWT.MenuDetect:
					menu.setLocation(event.x, event.y);
					menu.setVisible(true);
					break;
				}
			}
		};
		tree.addListener(SWT.MenuDetect,listener);
	}
	
	public Tree getTreeWidget(){
		return tree;
	}
	
	private void addWiki(Wiki w){
		new WikiItem(tree, SWT.NONE, w);
	}
	
	private void removeWiki(Wiki w){
		for(TreeItem item : tree.getItems()){
			if(item.getData() == w){
				item.dispose();
				break;
			}
		}
	}
	
	private void addWikiPage(WikiPage p){
		for(TreeItem item : tree.getItems()){
			if(item.getData() == p.getParent()){
				new WikiPageItem(item, SWT.NONE, p);
				break;
			}
		}
	}
	
	private void removeWikiPage(WikiPage p){
		method:
		for(TreeItem parent : tree.getItems()){
			if(parent.getData() == p.getParent()){
				for(TreeItem child : parent.getItems()){
					if(child.getData() == p){
						child.dispose();
						break method;
					}
				}
			}
		}
	}

	public void stateChanged(ChangeEvent e) {
		if(e.data instanceof Wiki){
			Wiki w = (Wiki) e.data;
			switch(e.status){
			case WikiManager.ADD:
				addWiki(w);
				break;
			case WikiManager.REMOVE:
				removeWiki(w);
				break;
			}
		}else if(e.data instanceof WikiPage){
			WikiPage p = (WikiPage) e.data;
			switch(e.status){
			case WikiManager.OPEN_PAGE:
				addWikiPage(p);
				break;
			case WikiManager.CLOSE_PAGE:
				removeWikiPage(p);
				break;
			}
		}
	}
}
