package net.kldp.zeta.wherithlov.data;


/**
 * ChannelPane의 UserListModel에서 사용하기 위한 Wrapping Class
 * 
 * @author ni2 (netisinfinite@gmail.com)
 * @version 0.1 11/25/06
 * This code licensed under the terms of the GPL.  See doc/LICENSE.
 */
public class AdvUser implements Comparable<AdvUser>{
	private String prefix;
	private String nick;
	private String lowerNick;
	
	public AdvUser(String prefix, String nick) {
		this.prefix = prefix;
		this.nick = nick;
		this.lowerNick = nick.toLowerCase();
	}
	
	public String getPrefix() {
		return prefix;
	}
	
	public boolean isOperator() {
		return prefix.indexOf('@') >= 0;
	}
	
	public boolean hasVoice() {
		return prefix.indexOf('+') >= 0;
	}        
	
	public String getNick() {
		return nick;
	}
	
	public String toString() {
		return this.prefix + this.nick;
	}
	
	public boolean equals(String nick) {
		return nick.toLowerCase().equals(lowerNick);
	}
	
	public boolean equals(Object o) {
		if (o instanceof AdvUser) {
			AdvUser other = (AdvUser) o;
			return other.lowerNick.equals(lowerNick);
		}
		return false;
	}
	
	public int hashCode() {
		return lowerNick.hashCode();
	}
	
	public int compareTo(AdvUser user) {
		return user.lowerNick.compareTo(lowerNick);
	}
}