package net.kldp.zeta.wherithlov.data;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ChannelCollection implements Iterable<Channel>{
	private List<Channel> channels = new ArrayList<Channel>();
	private List<IChannelCollectionListener> listeners = new ArrayList<IChannelCollectionListener>();
	
	public void addListener(IChannelCollectionListener listener){
		listeners.add(listener);
	}
	
	public void add(Channel channel){
		channels.add(channel);
		channelAdded(channel);
	}
	
	public void remove(Channel channel){
		channels.remove(channel);
		channelRemoved(channel);
	}
	
	public Channel get(String channelName){
		Channel result = null;
		for(Channel c : channels){
			if(c.name.equals(channelName)){
				result = c;
				break;
			}
		}
		return result;
	}
	
	public Channel get(Server server, String channelName){
		Channel result = null;
		for(Channel c : channels){
			if(c.name.equals(channelName) && c.server.host.equals(server.host)){
				result = c;
				break;
			}
		}
		return result;
	}
	
	/*
	private void channelCollectionChanged(){
		for(IChannelCollectionListener listener : listeners){
			listener.channelCollectionChanged();
		}
	}*/
	
	private void channelAdded(Channel channel){
		for(IChannelCollectionListener listener : listeners){
			listener.channelAdded(channel);
		}
	}
	
	private void channelRemoved(Channel channel){
		for(IChannelCollectionListener listener : listeners){
			listener.channelRemoved(channel);
		}
	}

	@Override
	public Iterator<Channel> iterator() {
		return channels.iterator();
	}
}
