package net.kldp.zeta.wherithlov.manager;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.UIManager;

/**
 * @author ni2 (netisinfinite@gmail.com)
 * @version 0.1 11/25/06
 * This code licensed under the terms of the GPL.  See doc/LICENSE.
 */
public class Configs {
	private static Properties properties = null;
	private static final String DEFAULT_PROPERTIES_FILENAME = "resources.configs.config";
	
	public static void init(){
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			//UIManager.setLookAndFeel("net.beeger.squareness.SquarenessLookAndFeel");
			//known resize bug http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=5079688
			JFrame.setDefaultLookAndFeelDecorated(true);
			JDialog.setDefaultLookAndFeelDecorated(true);
			
		} catch (Exception e) {
			System.err.println("Error loading L&F: " + e);
		}
	}
	
	public static void init_prop(){
		properties = new Properties();
		try{
			try {
				properties.load(new FileInputStream(DEFAULT_PROPERTIES_FILENAME));
			} catch (FileNotFoundException e) {
				properties.store(new FileOutputStream(DEFAULT_PROPERTIES_FILENAME), null);
			} 
		}catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static boolean check_prop(){
		if(properties == null)
			init_prop();
		return properties == null ? true : false; 
	}
	
	public static String get(String key){
		String result = null;
		
		if(check_prop())
			result = properties.getProperty(key);
		
		return result;
	}
	
	public static void set(String key, String value){
		if(check_prop())
			properties.setProperty(key, value);
	}
}
