package net.kldp.zeta.wherithlov.ui;

import java.util.List;

import javax.swing.DefaultListModel;

import net.kldp.zeta.wherithlov.data.AdvUser;

/**
 * 접속자 목록을 나타내는 JList에 바인딩되기 위한 ListModel 클래스이다. 
 * @author ni2 (netisinfinite@gmail.com)
 * @version 0.1 11/25/06
 * This code licensed under the terms of the GPL.  See doc/LICENSE.
 */
public class UserListModel extends DefaultListModel{
	private static final long serialVersionUID = 1L;
	
	public UserListModel(List<AdvUser> users){
		addElements(users);
	}
	
	public void sort(){
		boolean isSorted;
		do
		{
			isSorted = true;
			
			for(int i=1;i < getSize(); i++){
				if(((AdvUser) get(i)).compareTo((AdvUser) get(i-1)) > 0){
					Object u = get(i-1);
					set(i-1, get(i));
					set(i,u);
					
					isSorted = false;
				}
			}
		}while(!isSorted);
	}
	
	public void addElements(List<AdvUser> users){
		for(AdvUser u : users){
			addElement(u);
		}
		
		sort();
	}
	
	public int hasElement(String username){
		int y=-1;
		for(int i=0;i<getSize();i++){
			if(((AdvUser)get(i)).getNick().equals(username))
				y=i;
		}
		return y;
	}
	
	public void addElement(Object obj){
		if(obj instanceof AdvUser){
			super.addElement(obj);
			sort();
		}
	}
}
