package org.kldp.zeta;

import org.eclipse.swt.widgets.Text;

/**
 * @author ni2
 * @version 0.2, 09/10/06
 * This code licensed under the terms of the GPL.  See doc/LICENSE.
 *
 * 주어진 Text 위젯에 입력받은 로그를 출력하는 역할을 한다.
 */

public class SimpleLogger{
	public Text viewer;
	
	public SimpleLogger(Text viewer){
		viewer.setEditable(false);
		this.viewer = viewer;
	}
	
	/**
	 * 예외를 받아 viewer에 출력한다.
	 */
	public void printStackTrace(Exception e){
		StringBuilder sb = new StringBuilder();
		sb.append(e.toString());
		StackTraceElement stes[] = e.getStackTrace();
		for(StackTraceElement ste : stes){
			sb.append("\tat ");
			sb.append(ste.toString());
			sb.append("\n");
		}
		sb.append("\n\n");
		print(sb.toString());
	}
	
	/**
	 * 주어진 문자열을 viewer에 출력한다.
	 */
	public void print(String s){
		viewer.append(s);
	}
	
	/**
	 * newline 문자를 출력한다.
	 */
	public void println(){
		viewer.append("\n");
	}
	
	/**
	 * 주어진 문자열을 viewer에 출력하고 newlinet 문자를 덧붙인다.
	 */
	public void println(String s){
		print(s);
		println();
	}
}

